<!-- HTML header for doxygen 1.8.18-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=9" />
    <meta name="generator" content="Doxygen 1.9.1" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <title>VizBlocks: src/LEDBehaviours.h Source File</title>
    <link href="tabs.css" rel="stylesheet" type="text/css" />
    <script type="text/javascript" src="jquery.js"></script>
    <script type="text/javascript" src="dynsections.js"></script>
     <link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
    <link href="my_customdoxygen.css" rel="stylesheet" type="text/css" />
  </head>
  <body>
    <div id="top">
      <!-- do not remove this div, it is closed by doxygen! -->
      <header id="header" class="desktop">
        <div>
          <div class="inner-header">
            <div class="logotype">
              <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/" aria-hidden="true" title="Site home"
                >VizBlocks</a
              >
            </div>
            <div class="navigation">
              <button
                onclick="toggleBurger()"
                type="button"
                aria-label="toggle burger menu"
              >
                <i class="fa fa-bars"></i>
              </button>
              <nav id="menu" class="collapse">
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/" class="home">Home</a>
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/about" class="about">About</a>
                <a
                  href="https://edinburgh-college-of-art.github.io/vizblocks-website/tutorials/0_getting_started.html"
                  class="start"
                  >Get Started</a
                >
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/tutorials" class="tutorials"
                  >Tutorials</a
                >
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/docs/html" class="docs"
                  >Technical Info</a
                >
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/contact" class="content">Contact</a>
              </nav>
            </div>
          </div>
        </div>
        <script>
          const toggleBurger = () => {
            const menu = document.getElementById("menu");
            if (menu.className === "collapse") {
              menu.className = "extend";
            } else {
              menu.className = "collapse";
            }
          };
          const touchDevice = "ontouchstart" in document.documentElement;
          if (touchDevice) {
            const header = document.getElementById("header");
            header.className = "mobile";
          }
        </script>
      </header>
      <!-- end header part -->
    </div>
  </body>
</html>
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">LEDBehaviours.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_l_e_d_behaviours_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef LED_BEHAVIOUR_h</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define LED_BEHAVIOUR_h</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#include &lt;Arduino.h&gt;</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_behaviours_8h.html">Behaviours.h</a>&quot;</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &lt;Adafruit_NeoPixel.h&gt;</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160; </div>
<div class="line"><a name="l00017"></a><span class="lineno"><a class="line" href="class_light_some_l_e_ds.html">   17</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_light_some_l_e_ds.html">LightSomeLEDs</a> : <span class="keyword">public</span> <a class="code" href="class_behaviour.html">Behaviour</a></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;{</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    Adafruit_NeoPixel* _strip;</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    uint32_t _color;</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160; </div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00023"></a><span class="lineno"><a class="line" href="class_light_some_l_e_ds.html#a5f7dac6c76c51f9798c9c7e4bd870885">   23</a></span>&#160;    <a class="code" href="class_light_some_l_e_ds.html#a5f7dac6c76c51f9798c9c7e4bd870885">LightSomeLEDs</a>(Adafruit_NeoPixel* strip, String <a class="code" href="class_behaviour.html#a766009be6f0ed1acd74d4ba5c138a7bd">name</a> = <span class="stringliteral">&quot;LightSome&quot;</span>, uint32_t color=0xFFFFFFFF);</div>
<div class="line"><a name="l00024"></a><span class="lineno"><a class="line" href="class_light_some_l_e_ds.html#a1160de6497768ba1b20a3a7a29e0bb70">   24</a></span>&#160;    <span class="keywordtype">char</span>* <a class="code" href="class_light_some_l_e_ds.html#a1160de6497768ba1b20a3a7a29e0bb70">args</a>();</div>
<div class="line"><a name="l00025"></a><span class="lineno"><a class="line" href="class_light_some_l_e_ds.html#a25206d0ecbfc9d5cdb2cc19fde72a79e">   25</a></span>&#160;    String <a class="code" href="class_light_some_l_e_ds.html#a25206d0ecbfc9d5cdb2cc19fde72a79e">start</a>(String <a class="code" href="class_light_some_l_e_ds.html#a1160de6497768ba1b20a3a7a29e0bb70">args</a>);</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;};</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160; </div>
<div class="line"><a name="l00032"></a><span class="lineno"><a class="line" href="class_light_all_l_e_ds.html">   32</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_light_all_l_e_ds.html">LightAllLEDs</a> : <span class="keyword">public</span> <a class="code" href="class_behaviour.html">Behaviour</a></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;{</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    Adafruit_NeoPixel* _strip;</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    uint32_t _hue;</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    uint32_t _sat;</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160; </div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00039"></a><span class="lineno"><a class="line" href="class_light_all_l_e_ds.html#a41ee1848be65c91085aadb3dcfc3b6ce">   39</a></span>&#160;    <a class="code" href="class_light_all_l_e_ds.html#a41ee1848be65c91085aadb3dcfc3b6ce">LightAllLEDs</a>(Adafruit_NeoPixel* strip, String <a class="code" href="class_behaviour.html#a766009be6f0ed1acd74d4ba5c138a7bd">name</a> = <span class="stringliteral">&quot;LightAll&quot;</span>, uint32_t hue=0, uint32_t sat=0);</div>
<div class="line"><a name="l00040"></a><span class="lineno"><a class="line" href="class_light_all_l_e_ds.html#a8fcab516a3136401613e131507b0203e">   40</a></span>&#160;    <span class="keywordtype">char</span>* <a class="code" href="class_light_all_l_e_ds.html#a8fcab516a3136401613e131507b0203e">args</a>();</div>
<div class="line"><a name="l00041"></a><span class="lineno"><a class="line" href="class_light_all_l_e_ds.html#ad2e6d7b6230f58356065c767df62ea7f">   41</a></span>&#160;    String <a class="code" href="class_light_all_l_e_ds.html#ad2e6d7b6230f58356065c767df62ea7f">start</a>(String <a class="code" href="class_light_all_l_e_ds.html#a8fcab516a3136401613e131507b0203e">args</a>);</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160; </div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;};</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160; </div>
<div class="line"><a name="l00049"></a><span class="lineno"><a class="line" href="class_breathe_l_e_ds.html">   49</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_breathe_l_e_ds.html">BreatheLEDs</a> : <span class="keyword">public</span> <a class="code" href="class_behaviour.html">Behaviour</a></div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;{</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    Adafruit_NeoPixel* _strip;</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    uint _hue;</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    uint _sat;</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    int32_t _current = 0;</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;     <span class="comment">//Allows us to have slightly slower behaviours on the go...</span></div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <span class="keywordtype">int</span> _factor = 4;</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <span class="keywordtype">int</span> _rate = 0;</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <span class="keywordtype">int</span> _direction = 1;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160; </div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00061"></a><span class="lineno"><a class="line" href="class_breathe_l_e_ds.html#ac5523d67d96d36e85a53c731aaf1b01c">   61</a></span>&#160;    <a class="code" href="class_breathe_l_e_ds.html#ac5523d67d96d36e85a53c731aaf1b01c">BreatheLEDs</a>(Adafruit_NeoPixel* strip, String <a class="code" href="class_behaviour.html#a766009be6f0ed1acd74d4ba5c138a7bd">name</a> = <span class="stringliteral">&quot;Breathe&quot;</span>, uint32_t hue=0, uint32_t sat=0);</div>
<div class="line"><a name="l00062"></a><span class="lineno"><a class="line" href="class_breathe_l_e_ds.html#aecd600f1c7b2bcaf25a08099b18eaad1">   62</a></span>&#160;    <span class="keywordtype">char</span>* <a class="code" href="class_breathe_l_e_ds.html#aecd600f1c7b2bcaf25a08099b18eaad1">args</a>();</div>
<div class="line"><a name="l00063"></a><span class="lineno"><a class="line" href="class_breathe_l_e_ds.html#a81bb278dcb88bf89c3886ec6a3749de7">   63</a></span>&#160;    String <a class="code" href="class_breathe_l_e_ds.html#a81bb278dcb88bf89c3886ec6a3749de7">start</a>(String <a class="code" href="class_breathe_l_e_ds.html#aecd600f1c7b2bcaf25a08099b18eaad1">args</a>);</div>
<div class="line"><a name="l00064"></a><span class="lineno"><a class="line" href="class_breathe_l_e_ds.html#aa73b6336ef075436fa01b7ffc999f939">   64</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_breathe_l_e_ds.html#aa73b6336ef075436fa01b7ffc999f939">update</a>();</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160; </div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;};</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160; </div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="ttc" id="a_behaviours_8h_html"><div class="ttname"><a href="_behaviours_8h.html">Behaviours.h</a></div><div class="ttdoc">Functionality for block behaviours.</div></div>
<div class="ttc" id="aclass_behaviour_html"><div class="ttname"><a href="class_behaviour.html">Behaviour</a></div><div class="ttdoc">Parent class for all other behaviours.</div><div class="ttdef"><b>Definition:</b> Behaviours.h:20</div></div>
<div class="ttc" id="aclass_behaviour_html_a766009be6f0ed1acd74d4ba5c138a7bd"><div class="ttname"><a href="class_behaviour.html#a766009be6f0ed1acd74d4ba5c138a7bd">Behaviour::name</a></div><div class="ttdeci">virtual String name()</div></div>
<div class="ttc" id="aclass_breathe_l_e_ds_html"><div class="ttname"><a href="class_breathe_l_e_ds.html">BreatheLEDs</a></div><div class="ttdoc">Behaviour that cycles all LEDs from full to minimum brightness and back at a speed specified as its a...</div><div class="ttdef"><b>Definition:</b> LEDBehaviours.h:50</div></div>
<div class="ttc" id="aclass_breathe_l_e_ds_html_a81bb278dcb88bf89c3886ec6a3749de7"><div class="ttname"><a href="class_breathe_l_e_ds.html#a81bb278dcb88bf89c3886ec6a3749de7">BreatheLEDs::start</a></div><div class="ttdeci">String start(String args)</div></div>
<div class="ttc" id="aclass_breathe_l_e_ds_html_aa73b6336ef075436fa01b7ffc999f939"><div class="ttname"><a href="class_breathe_l_e_ds.html#aa73b6336ef075436fa01b7ffc999f939">BreatheLEDs::update</a></div><div class="ttdeci">void update()</div></div>
<div class="ttc" id="aclass_breathe_l_e_ds_html_ac5523d67d96d36e85a53c731aaf1b01c"><div class="ttname"><a href="class_breathe_l_e_ds.html#ac5523d67d96d36e85a53c731aaf1b01c">BreatheLEDs::BreatheLEDs</a></div><div class="ttdeci">BreatheLEDs(Adafruit_NeoPixel *strip, String name=&quot;Breathe&quot;, uint32_t hue=0, uint32_t sat=0)</div></div>
<div class="ttc" id="aclass_breathe_l_e_ds_html_aecd600f1c7b2bcaf25a08099b18eaad1"><div class="ttname"><a href="class_breathe_l_e_ds.html#aecd600f1c7b2bcaf25a08099b18eaad1">BreatheLEDs::args</a></div><div class="ttdeci">char * args()</div></div>
<div class="ttc" id="aclass_light_all_l_e_ds_html"><div class="ttname"><a href="class_light_all_l_e_ds.html">LightAllLEDs</a></div><div class="ttdoc">Behaviour that lights up all the LEDs to a brightness specified as its argument.</div><div class="ttdef"><b>Definition:</b> LEDBehaviours.h:33</div></div>
<div class="ttc" id="aclass_light_all_l_e_ds_html_a41ee1848be65c91085aadb3dcfc3b6ce"><div class="ttname"><a href="class_light_all_l_e_ds.html#a41ee1848be65c91085aadb3dcfc3b6ce">LightAllLEDs::LightAllLEDs</a></div><div class="ttdeci">LightAllLEDs(Adafruit_NeoPixel *strip, String name=&quot;LightAll&quot;, uint32_t hue=0, uint32_t sat=0)</div></div>
<div class="ttc" id="aclass_light_all_l_e_ds_html_a8fcab516a3136401613e131507b0203e"><div class="ttname"><a href="class_light_all_l_e_ds.html#a8fcab516a3136401613e131507b0203e">LightAllLEDs::args</a></div><div class="ttdeci">char * args()</div></div>
<div class="ttc" id="aclass_light_all_l_e_ds_html_ad2e6d7b6230f58356065c767df62ea7f"><div class="ttname"><a href="class_light_all_l_e_ds.html#ad2e6d7b6230f58356065c767df62ea7f">LightAllLEDs::start</a></div><div class="ttdeci">String start(String args)</div></div>
<div class="ttc" id="aclass_light_some_l_e_ds_html"><div class="ttname"><a href="class_light_some_l_e_ds.html">LightSomeLEDs</a></div><div class="ttdoc">Behaviour that lights up a number of LEDs specified as its argument.</div><div class="ttdef"><b>Definition:</b> LEDBehaviours.h:18</div></div>
<div class="ttc" id="aclass_light_some_l_e_ds_html_a1160de6497768ba1b20a3a7a29e0bb70"><div class="ttname"><a href="class_light_some_l_e_ds.html#a1160de6497768ba1b20a3a7a29e0bb70">LightSomeLEDs::args</a></div><div class="ttdeci">char * args()</div></div>
<div class="ttc" id="aclass_light_some_l_e_ds_html_a25206d0ecbfc9d5cdb2cc19fde72a79e"><div class="ttname"><a href="class_light_some_l_e_ds.html#a25206d0ecbfc9d5cdb2cc19fde72a79e">LightSomeLEDs::start</a></div><div class="ttdeci">String start(String args)</div></div>
<div class="ttc" id="aclass_light_some_l_e_ds_html_a5f7dac6c76c51f9798c9c7e4bd870885"><div class="ttname"><a href="class_light_some_l_e_ds.html#a5f7dac6c76c51f9798c9c7e4bd870885">LightSomeLEDs::LightSomeLEDs</a></div><div class="ttdeci">LightSomeLEDs(Adafruit_NeoPixel *strip, String name=&quot;LightSome&quot;, uint32_t color=0xFFFFFFFF)</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- HTML footer for doxygen 1.8.18-->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.9.1
</small></address>
</body>
</html>
